/**
 * @package koa-files
 * @license MIT
 * @version 2.3.1
 * @author nuintun <nuintun@qq.com>
 * @description A static files serving middleware for koa.
 * @see https://github.com/nuintun/koa-files#readme
 */

'use strict';

const Send = require('./Send.cjs');

/**
 * @module index
 * @license MIT
 * @author nuintun
 */
/**
 * @function server
 * @param {string} root
 * @param {Options} options
 */
function server(root, options = {}) {
  if (options.defer) {
    return async (ctx, next) => {
      await next();
      await new Send(ctx, root, options).response();
    };
  }
  return async (ctx, next) => {
    const respond = await new Send(ctx, root, options).response();
    !respond && (await next());
  };
}

module.exports = server;
